#ifndef _PCM_STUDIO_H
#define _PCM_STUDIO_H

#include "codec_studio.h"

typedef struct snd_studio_data_subchn1 snd_studio_data_subchn1_t;
struct snd_studio_data_subchn1 {
	int		open_tag;
	unsigned long	idx_sample;
}; /* snd_studio_data_subchn1 */

typedef struct snd_pcm_studio snd_pcm_studio_t;
struct snd_pcm_studio {
	snd_card_t	*card;
	snd_pcm_t	*pcm;
	unsigned	ipcm;
	unsigned	usage;	/* # of opened channels */
	
	int		error_codec;
	int		on_rt_error;

	/* Only for reference, not owned */
	codec_studio_t	*codec[SND_CARDS];
	unsigned int	ncodecs;

	unsigned int	frame_per_codec;
	unsigned int	frame_per_channel;

	void		*bufplayback;
	void		*bufrecord;
	void		*bufmonitor;

	spinlock_t		access_lock;
	struct timer_list	t_adat_sync;

	struct {
		unsigned long	nint;
		unsigned long	nrt_errors;     /* Realtime errors */
		unsigned long	mismatched_codecs;
		unsigned long	period_int;
		unsigned long	time_service;
		unsigned long	time_unsync;
		unsigned long	debug_point;
	} stat;

	snd_info_entry_t *entry_proc;

}; /* struct snd_pcm_studio */

int snd_pcm_studio_interrupt(
	snd_pcm_studio_t *pcm_s);
void snd_pcm_refresh_bitmaps_read (
	snd_pcm_studio_t *pcm_s);
int snd_pcm_studio_test_routes(
	snd_pcm_studio_t *pcm_s);
void snd_pcm_studio_toggle_routing(
	snd_pcm_studio_t	*pcm_s,
	int			on_off);
void snd_pcm_studio_free (
	snd_pcm_studio_t *pcm_s);
snd_pcm_studio_t *snd_pcm_studio_create (
	snd_card_t	*card,
	unsigned	ipcm,
	unsigned	ncards);

#endif /* _PCM_STUDIO_H */
