#ifndef _STUDIO_H
#define _STUDIO_H

#define STUDIO_CARDS 8

#include "config_studio.h"

/* ALSA (and Linux) includes */
#include "driver.h"
#include "initval.h"
#include "switch.h"
#include "info.h"
#include "control.h"
#include "pcm.h"
#include "pcm1.h"

#ifndef PCI_VENDOR_ID_SONORUS
#define PCI_VENDOR_ID_SONORUS           0x1057
#endif
#ifndef PCI_DEVICE_ID_SONORUS_STUDIO
#define PCI_DEVICE_ID_SONORUS_STUDIO	0x1801
#endif

/* While not distributed with Alsa */
#include "asoundid.h"
#define SND_CARD_TYPE_STUDIO	(SND_CARD_TYPE_LAST+1)

/* ./include/bootdsp.h includes the DSP code for */
/* 64, 128, 256 and 512 samples per channel per  */
/* interrupt.                                    */
/* !!!! WARNING
* Only b64 DSP code works. Other DSP codes are involved
* on system hangups during PCI read tranfer. The error
* has been reproduced on several hardware platforms and
* companion peripheral cards. The error has NOT been
* tested with another kernel than 2.2.5. For now, it is
* sure to use only b64 code.
*/

#define NSAMPLES	64
#define MAX_NSAMPLES	512

#endif /* _STUDIO_H */
