#include <stdio.h>
#include "2020d.h"
#include "2020k2.h"

#define ALTERA_SIZE 7889

/*
 * Merge 2020d and 2020k2 unsigned char arrays into a
 * single u32 array
 */

main (){
	FILE		*fp;
	unsigned	idx;
	unsigned long	data;

	if (!(fp=fopen ("fpga.h", "w+"))){
		fprintf (stderr, "merge_altera: fopen error\n");
		return 1;
	}

	fprintf (fp, "/* Generated automatically by merge_altera. Do not edit. */\n\n");
	fprintf (fp, "/* 2ADAT in, 2ADAT out, Rev D-F, altera2020 .... 1st LSB */\n");
	fprintf (fp, "/* 2ADAT in, 2ADAT out, Rev A-C, altera2020 .... 2nd LSB */\n");
	fprintf (fp, "\n");

	fprintf (fp, "#ifndef _FPGA_H\n");
	fprintf (fp, "#define _FPGA_H\n\n");

	fprintf (fp, "static u32 altera2020[%u] = {", ALTERA_SIZE);

	for (idx=0; idx<ALTERA_SIZE; idx++){
		data  = 0L;
		data |= ((unsigned long)altera2020k2[idx] << 8) & 0xff00L;
		data |= ((unsigned long)altera2020d [idx] << 0) & 0x00ffL;
		fprintf (fp, "0x%08lx, ", data);
		if (idx%10) continue;
		fprintf (fp, "\n");
        }
	fprintf (fp, "};\n\n");

	fprintf (fp, "#endif /* _FPGA_H */\n");

	return 0;
}